     PROGRAM

     MAP
       MODULE('Windows API')
         xzCreateFile(*CString,ULong,ULong,Long,ULong,ULong,Signed),Signed,Pascal,Raw,Name('CreateFileA')
         xzGetFileTime(Signed,Long,Long,Long),Signed,Proc,Pascal,Raw,Name('GetFileTime')
         xzSetFileTime(Signed,Long,Long,Long),Signed,Proc,Pascal,Raw,Name('SetFileTime')
         xzCloseHandle(Signed),Signed,Proc,Pascal,Raw,Name('CloseHandle')
         xzFileTimeToSystemTime(*xzFileTime,*xzSystemTime),bool,pascal,raw,proc,name('FileTimeToSystemTime')
         xzSystemTimeToFileTime(*xzSystemTime,*xzFileTime),bool,pascal,raw,proc,name('SystemTimeToFileTime')
         xzLocalFileTimeToFileTime(*xzFileTime,*xzFileTime),BOOL,PASCAL,RAW,proc,name('LocalFileTimeToFileTime')
         xzFileTimeToLocalFileTime(*xzFileTime,*xzFileTime),BOOL,PASCAL,RAW,proc,name('FileTimeToLocalFileTime')
         xzSystemTimeToTzSpecificLocalTime(BYTE,*xzSystemTime,*xzSystemTime),BOOL,PASCAL,RAW,PROC,NAME('SystemTimeToTzSpecificLocalTime')
       END
       xzSetFTime(STRING FileName, BYTE DateType, LONG Date, LONG Time)
       xzGetFTime(STRING FileName, BYTE DateType, *LONG Date, *LONG Time)
     END                         

xzCreateDate   EQUATE(1)
xzWriteDate    EQUATE(2)
xzAccessDate   EQUATE(3)


xzFileTime     GROUP,TYPE
_LoDateTime      ULONG
_HiDateTime      ULONG
               END

xzSystemTime   GROUP,TYPE
wYear            SHORT
wMonth           SHORT
wDayOfWeek       SHORT
wDay             SHORT
wHour            SHORT
wMinute          SHORT
wSecond          SHORT
wMilliseconds    SHORT
               END

xzFileName          CSTRING(260)
xzFileTimeCreate    GROUP(xzFileTime)
                    END
xzFileTimeAccess    GROUP(xzFileTime)
                    END
xzFileTimeWrite     GROUP(xzFileTime)
                    END
xzSystemT           GROUP(xzSystemTime)
                    END

LOC:FileName   STRING(255)
LOC:CDate      LONG
LOC:CTime      LONG
LOC:WDate      LONG
LOC:WTime      LONG
LOC:ADate      LONG
LOC:ATime      LONG

Window WINDOW('Set/Get FileDateTime'),AT(,,323,125),FONT('MS Sans Serif',8,,FONT:regular),CENTER,DOUBLE
       BOX,AT(-34,0,357,69),USE(?Box1),COLOR(0FFE1E1H),FILL(0FFE1E1H)
       PROMPT('<255> :'),AT(4,8),USE(?Prompt1),TRN
       ENTRY(@s255),AT(48,8,229,10),USE(LOC:FileName),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       BUTTON(' '),AT(48,24,113,16),USE(?SelectFile),FONT(,,COLOR:White,,CHARSET:ANSI)
       BUTTON(' /<255>'),AT(164,24,113,16),USE(?GetDate),FONT(,,COLOR:White,,CHARSET:ANSI)
       BUTTON('  '),AT(48,44,113,16),USE(?Exit),FONT(,,COLOR:White,,CHARSET:ANSI)
       BUTTON(' /<255>'),AT(164,44,113,16),USE(?SetDate),FONT(,,COLOR:White,,CHARSET:ANSI)
       PROMPT(' <255>:'),AT(44,76),USE(?Prompt2),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@D06.),AT(108,76,47,10),USE(LOC:CDate),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       PROMPT('<255> <255>:'),AT(164,76),USE(?Prompt21),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@T04),AT(232,76,47,10),USE(LOC:CTime),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       BOX,AT(0,68,323,57),USE(?Box2),COLOR(0A40052H),FILL(0A40052H)
       PROMPT(' <255>:'),AT(44,92),USE(?Prompt3),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@D06.),AT(108,92,47,10),USE(LOC:WDate),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       PROMPT('<255> <255>:'),AT(164,92),USE(?Prompt31),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@T04),AT(232,92,47,10),USE(LOC:WTime),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       PROMPT(' :'),AT(44,108),USE(?Prompt4),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@D06.),AT(108,108,47,10),USE(LOC:ADate),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
       PROMPT('<255> :'),AT(164,108),USE(?Prompt41),TRN,FONT(,,COLOR:White,,CHARSET:ANSI)
       ENTRY(@T04),AT(232,108,47,10),USE(LOC:ATime),RIGHT(2),COLOR(0FFF0F8H,0800040H,0FF9F9FH)
     END

  CODE
  LOC:FileName = 'test.txt'
  OPEN(Window)
  ?SelectFile{PROP:Color} = 0A40052H
  ?GetDate{PROP:Color} = 0A40052H
  ?SetDate{PROP:Color} = 0A40052H
  ?Exit{PROP:Color} = 0A40052H
  DO GetDateTime
  ACCEPT
    CASE ACCEPTED()
    OF ?Exit
      BREAK
    OF ?SelectFile
      IF FILEDIALOG(' ', LOC:FileName, 'All files|*.*', FILE:KeepDir+FILE:LongName)
        DO GetDateTime
      END
    OF ?GetDate
      DO GetDateTime
    OF ?SetDate
      xzSetFTime(LOC:FileName, xzCreateDate, LOC:CDate, LOC:CTime)
      xzSetFTime(LOC:FileName, xzWriteDate, LOC:WDate, LOC:WTime)
      xzSetFTime(LOC:FileName, xzAccessDate, LOC:ADate, LOC:ATime)
    END
  END
  CLOSE(Window)

GetDateTime     ROUTINE
  xzGetFTime(LOC:FileName, xzCreateDate, LOC:CDate, LOC:CTime)
  xzGetFTime(LOC:FileName, xzWriteDate, LOC:WDate, LOC:WTime)
  xzGetFTime(LOC:FileName, xzAccessDate, LOC:ADate, LOC:ATime)
  DISPLAY

!----------------------------------------------------------------------------------------------------------------------
xzGetFTime          PROCEDURE(STRING FileName, BYTE DateType, *LONG Date, *LONG Time)
  CODE
  xzFileName = CLIP(FileName)
  Handle# = xzCreateFile(xzFileName,0C0000000h,0,0,3,080h,0)
  IF Handle# > 0
    xzGetFileTime(Handle#,ADDRESS(xzFileTimeCreate),ADDRESS(xzFileTimeAccess),ADDRESS(xzFileTimeWrite))
    xzCloseHandle(Handle#)
  END
  CASE DateType
  OF xzCreateDate
    xzFileTimeToLocalFileTime(xzFileTimeCreate,xzFileTimeCreate)
    xzFileTimeToSystemTime(xzFileTimeCreate, xzSystemT)
  OF xzWriteDate
    xzFileTimeToLocalFileTime(xzFileTimeWrite,xzFileTimeWrite)
    xzFileTimeToSystemTime(xzFileTimeWrite, xzSystemT)
  OF xzAccessDate
    xzFileTimeToLocalFileTime(xzFileTimeAccess,xzFileTimeAccess)
    xzFileTimeToSystemTime(xzFileTimeAccess, xzSystemT)
  END
  Date = DATE(xzSystemT.wMonth, xzSystemT.wDay, xzSystemT.wYear)
  Time = DEFORMAT(FORMAT(xzSystemT.wHour, @N02) & ':' & FORMAT(xzSystemT.wMinute, @N02) & ':' & FORMAT(xzSystemT.wSecond, @N02), @T04)
!----------------------------------------------------------------------------------------------------------------------
xzSetFTime          PROCEDURE(STRING FileName, BYTE DateType, LONG Date, LONG Time)
FDate               STRING(@D12)
FTime               STRING(@T5)
  CODE
  xzFileName = CLIP(FileName)
  xzGetFTime(FileName,DateType, W1#,W2#)
  Handle# = xzCreateFile(xzFileName,0C0000000h,0,0,3,080h,0)
  IF Handle# > 0
    FDate = Date
    FTime = Time
    xzSystemT.wMonth  = Fdate[5:6]
    xzSystemT.wDay    = Fdate[7:8]
    xzSystemT.wYear   = Fdate[1:4]
    xzSystemT.wHour   = Ftime[1:2]
    xzSystemT.wMinute = Ftime[3:4]
    xzSystemT.wSecond = Ftime[5:6]
    CASE DateType
    OF xzCreateDate
      xzSystemTimeToFileTime(xzSystemT, xzFileTimeCreate)
      xzLocalFileTimeToFileTime(xzFileTimeCreate,xzFileTimeCreate)
    OF xzWriteDate
      xzSystemTimeToFileTime(xzSystemT, xzFileTimeWrite)
      xzLocalFileTimeToFileTime(xzFileTimeWrite,xzFileTimeWrite)
    OF xzAccessDate
      xzSystemTimeToFileTime(xzSystemT, xzFileTimeAccess)
      xzLocalFileTimeToFileTime(xzFileTimeAccess,xzFileTimeAccess)
    END
    xzSetFileTime(Handle#,ADDRESS(xzFileTimeCreate),ADDRESS(xzFileTimeAccess),ADDRESS(xzFileTimeWrite))
    xzCloseHandle(Handle#)
  END
!----------------------------------------------------------------------------------------------------------------------
